<?php

  require('includes/application_top.php');    // Zencart integration



require("dfd.config.php");

if ( $_GET['csv_split'] ) {
$debugger = NULL;  // 1 or NULL for debugging...turns on / off the debug mode
$file = $_GET['csv_split'];
}
elseif ( $_GET['csv_view'] ) {
$debugger = 1;  // 1 or NULL for debugging...turns on / off the debug mode
$file = $_GET['csv_view'];
}


$handle = fopen($file, "r");


if ( !$_GET['split_count'] ) {
$split_count = 1;
}
else {
$split_count = $_GET['split_count'];
}



if ( !$_GET['file_pointer'] ) {
$file_pointer = 0;
}
else {
$file_pointer = $_GET['file_pointer'];
}

?><!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html <?php echo HTML_PARAMS;  // Zencart integration ?>>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=<?php  echo CHARSET;  // Zencart integration ?>">
<title><?php echo TITLE;  // Zencart integration ?></title>
<?php
if ( $_GET['wait'] ) {
?>
<meta http-equiv="refresh" content="1; url=<?php echo $_SERVER['PHP_SELF'] . "?csv_split=" . $file . "&split_count=" . $split_count . "&file_pointer=" . $file_pointer . "&g_row=" . ($_GET['g_row'] + $row); ?>" />
<?php
}
?>
<link rel="stylesheet" type="text/css" href="includes/stylesheet.css">
<link rel="stylesheet" type="text/css" href="includes/cssjsmenuhover.css" media="all" id="hoverJS">
<script language="javascript" src="includes/menu.js"></script>
<script language="javascript" src="includes/general.js"></script>
<script type="text/javascript">
  
  function init()
  {
    cssjsmenu('navbar');
    if (document.getElementById)
    {
      var kill = document.getElementById('hoverJS');
      kill.disabled = true;
    }
  }
  
</script>
</head>
<body onload="init()" marginwidth="0" marginheight="0" topmargin="0" bottommargin="0" leftmargin="0" rightmargin="0" bgcolor="#FFFFFF">


<?php  require(DIR_WS_INCLUDES . 'header.php');  // Zencart integration ?>


<?php


if ( $file_pointer >= 0 ) {
fseek($handle, $file_pointer);
}


if ( $_GET['csv_view'] ) {
echo "<p><b><a href='dfd.csv.parser.php'><b>Return to the eBay Spreadsheet Conversion Index</b></a></p>";
}


if ( $_GET['wait'] ) {
$counted = $split_count - 1;
echo "<div style='padding: 20px;'><b style='color: red;'>Processed raw conversion file # $counted (spreadsheet rows ".($counted * $max - $max + 1)." through ".($_GET['g_row'] + $row).")...please wait...</b></div>";
}

else {


if ( $debugger ) {
echo "<table border='1'>";  // Debugging
}



// Parse the csv data
while ( ($data = fgetcsv($handle, 500000, $original_delimiter, $enclosure)) !== FALSE && $row <= $max - 1 ) {
    
	$num = count($data);
    $row++;
	
	
		if ( !$_SESSION['row_array'] ) {
		
		$_SESSION['row_array'] = array(
		'title'=>NULL,
		'description'=>NULL,
		'subtitle'=>NULL,
		'product_id_1'=>NULL,
		'product_id_2'=>NULL,
		'category'=>NULL,
		'category_number_1'=>NULL,
		'category_number_2'=>NULL,
		'category_number_3'=>NULL,
		'quantity_1'=>NULL,
		'quantity_2'=>NULL,
		'starting_price'=>NULL,
		'fixed_price'=>NULL,
		'buynow_price'=>NULL,
		'picurl_1'=>NULL,
		'picurl_2'=>NULL,
		'picurl_3'=>NULL,
		'picurl_4'=>NULL
		);
		
			foreach ( $data as $column_key => $column_value ) {
			
				if ( clean_header($column_value, $enclosure) == 'title' ) {
				$_SESSION['row_array']['title'] = $column_key;
				}
				
				
				if ( clean_header($column_value, $enclosure) == 'description' ) {
				$_SESSION['row_array']['description'] = $column_key;
				}
				
				
				if ( clean_header($column_value, $enclosure) == 'subtitle' ) {
				$_SESSION['row_array']['subtitle'] = $column_key;
				}
				
				
				if ( clean_header($column_value, $enclosure) == 'partnumber' ) {
				$_SESSION['row_array']['product_id_1'] = $column_key;
				}
				
				
				if ( clean_header($column_value, $enclosure) == 'modelnumber' ) {
				$_SESSION['row_array']['product_id_2'] = $column_key;
				}
				
				
				if ( clean_header($column_value, $enclosure) == 'category1' ) {
				$_SESSION['row_array']['category'] = $column_key;
				}
				
				
				if ( clean_header($column_value, $enclosure) == 'categorynumber' ) {
				$_SESSION['row_array']['category_number_1'] = $column_key;
				}
				
				
				if ( clean_header($column_value, $enclosure) == 'category1number' ) {
				$_SESSION['row_array']['category_number_2'] = $column_key;
				}
				
				
				if ( clean_header($column_value, $enclosure) == 'categorynumber1' ) {
				$_SESSION['row_array']['category_number_3'] = $column_key;
				}
				
				
				if ( clean_header($column_value, $enclosure) == 'quantity' ) {
				$_SESSION['row_array']['quantity_1'] = $column_key;
				}
				
				
				if ( clean_header($column_value, $enclosure) == 'quantitytolist' ) {
				$_SESSION['row_array']['quantity_2'] = $column_key;
				}
				
				
				if ( clean_header($column_value, $enclosure) == 'buyitnowprice' ) {
				$_SESSION['row_array']['buynow_price'] = $column_key;
				}
				
				
				if ( clean_header($column_value, $enclosure) == 'fixedprice' ) {
				$_SESSION['row_array']['fixed_price'] = $column_key;
				}
				
				
				if ( clean_header($column_value, $enclosure) == 'startingprice' ) {
				$_SESSION['row_array']['starting_price'] = $column_key;
				}
				
				
				if ( clean_header($column_value, $enclosure) == 'thumbnail' ) {
				$_SESSION['row_array']['picurl_1'] = $column_key;
				}
				
				
				if ( clean_header($column_value, $enclosure) == 'picurl' ) {
				$_SESSION['row_array']['picurl_2'] = $column_key;
				}
				
				
				if ( clean_header($column_value, $enclosure) == 'picture1' ) {
				$_SESSION['row_array']['picurl_3'] = $column_key;
				}
				
				
				if ( clean_header($column_value, $enclosure) == 'photooneurl' ) {
				$_SESSION['row_array']['picurl_4'] = $column_key;
				}
			
			
			}
		
		}
		
		if ( !$_SESSION['row_array']['title'] ) { ?>
		<div style='padding: 20px;'><b style='color: red;'>Your spreadsheet appears to be missing a header to identify each data column. <a href="dfd.csv.parser.php" style="color: red;">Try again</a> after double-checking your spreadsheet.</b></div>
		<?php
		exit;
		 }
	
	if ( $debugger ) {
	echo "<tr>";  // Debugging
	}
	
	

	
	if ( trim($data[$_SESSION['row_array']['category']]) ) {
	$ebay_category = trim($data[$_SESSION['row_array']['category']]);
	}
	elseif ( trim($data[$_SESSION['row_array']['category_number_1']]) ) {
	$ebay_category = trim($data[$_SESSION['row_array']['category_number_1']]);
	}
	elseif ( trim($data[$_SESSION['row_array']['category_number_2']]) ) {
	$ebay_category = trim($data[$_SESSION['row_array']['category_number_2']]);
	}
	elseif ( trim($data[$_SESSION['row_array']['category_number_3']]) ) {
	$ebay_category = trim($data[$_SESSION['row_array']['category_number_3']]);
	}
	
	
	
	if ( $ebay_category ) {
	
		$print_categories = NULL;
		$subcategory_scan = NULL;
		foreach ( return_category($subcategory_count, $ebay_category, $app_id, $site_id) as $new_category ) {
		$print_categories = $print_categories . $enclosure . $new_category . $enclosure . $converted_delimiter;
		$subcategory_scan = $subcategory_scan + 1;
		}
	
	}
	
	// Add extra blank columns if not all subcategory columns are used for this item
	if ( $subcategory_scan < $subcategory_count ) {
	
	$subcategory_offset = $subcategory_count - $subcategory_scan;
	
		$offset_loop = 0;
		while ( $offset_loop < $subcategory_offset ) {
		$print_categories = $print_categories . "\"\"" . $converted_delimiter;
		$offset_loop = $offset_loop + 1;
		}
	
	}
	
	
	$data[$_SESSION['row_array']['description']] = eregi_replace("\n", "", $data[$_SESSION['row_array']['description']]);
	
	if ( strlen($remove_start_description) > 10 ) {
	$data[$_SESSION['row_array']['description']] = eregi_replace($remove_start_description . "(.*)" . ( strlen($remove_end_description) > 10 ? $remove_end_description : '' ), $replace_start_description . $replace_end_description, $data[$_SESSION['row_array']['description']]);
	}
	
	
	require('dfd.lib/p_h_p/product.parsing.php');
	
	
		if ( is_numeric(preg_replace('/[^0-9\.]+[^\d]/', '', $data[$_SESSION['row_array']['buynow_price']]))
		&& preg_replace('/[^0-9\.]+[^\d]/', '', $data[$_SESSION['row_array']['buynow_price']]) > 0 ) {
		$price = preg_replace('/[^0-9\.]+[^\d]/', '', $data[$_SESSION['row_array']['buynow_price']]);
		}
		elseif ( is_numeric(preg_replace('/[^0-9\.]+[^\d]/', '', $data[$_SESSION['row_array']['fixed_price']]))
		&& preg_replace('/[^0-9\.]+[^\d]/', '', $data[$_SESSION['row_array']['fixed_price']]) > 0 ) {
		$price = preg_replace('/[^0-9\.]+[^\d]/', '', $data[$_SESSION['row_array']['fixed_price']]);
		}
		elseif ( is_numeric(preg_replace('/[^0-9\.]+[^\d]/', '', $data[$_SESSION['row_array']['starting_price']]))
		&& preg_replace('/[^0-9\.]+[^\d]/', '', $data[$_SESSION['row_array']['starting_price']]) > 0 ) {
		$price = preg_replace('/[^0-9\.]+[^\d]/', '', $data[$_SESSION['row_array']['starting_price']]);
		}
	
	
	//$price = preg_replace('/[^0-9\.]+[^\d]/', '', $price);
	
	
		if ( !trim($data[$_SESSION['row_array']['description']]) ) {
		$data[$_SESSION['row_array']['description']] = $data[$_SESSION['row_array']['title']] . "<p>&nbsp;</p>" . $data[$_SESSION['row_array']['subtitle']];
		}
	
	
		if ( trim($data[$_SESSION['row_array']['product_id_1']]) ) {
		$product_id = trim($data[$_SESSION['row_array']['product_id_1']]);
		}
		elseif ( trim($data[$_SESSION['row_array']['product_id_2']]) ) {
		$product_id = trim($data[$_SESSION['row_array']['product_id_2']]);
		}
		else {
		$product_id = $prod_id_prefix . trim(string_length(strip_title($data[$_SESSION['row_array']['title']]), 4)) . "_" . trim(string_length(md5($data[$_SESSION['row_array']['title']]), 3));
		}
	
	
		if ( trim($data[$_SESSION['row_array']['quantity_1']]) ) {
		$quantity = trim($data[$_SESSION['row_array']['quantity_1']]);
		}
		elseif ( trim($data[$_SESSION['row_array']['quantity_2']]) ) {
		$quantity = trim($data[$_SESSION['row_array']['quantity_2']]);
		}
	
	
		if ( eregi_replace("~", "", trim($data[$_SESSION['row_array']['picurl_1']])) ) {
		$picurl = trim($data[$_SESSION['row_array']['picurl_1']]);
		}
		elseif ( eregi_replace("~", "", trim($data[$_SESSION['row_array']['picurl_2']])) ) {
		$picurl = trim($data[$_SESSION['row_array']['picurl_2']]);
		}
		elseif ( eregi_replace("~", "", trim($data[$_SESSION['row_array']['picurl_3']])) ) {
		$picurl = trim($data[$_SESSION['row_array']['picurl_3']]);
		}
		elseif ( eregi_replace("~", "", trim($data[$_SESSION['row_array']['picurl_4']])) ) {
		$picurl = trim($data[$_SESSION['row_array']['picurl_4']]);
		}
	
	
		if ( !$debugger && $import_images == 1 ) {
		
		$picurl = import_image($picurl, '../images/', $product_id);
		
		}
	
	 $row_data = $enclosure . $product_id . $enclosure . 
	 			$converted_delimiter . 
				$enclosure . eregi_replace($enclosure, $enclosure.$enclosure, eregi_replace($converted_delimiter, "", $data[$_SESSION['row_array']['title']])) . $enclosure . 
				$converted_delimiter . 
				$enclosure . eregi_replace($enclosure, $enclosure.$enclosure, eregi_replace($converted_delimiter, "", $data[$_SESSION['row_array']['description']])) . $enclosure . 
				$converted_delimiter . 
				$enclosure . eregi_replace($converted_delimiter, "", $picurl) . $enclosure . 
				$converted_delimiter . 
				$enclosure . eregi_replace($converted_delimiter, "", $price) . $enclosure . 
				$converted_delimiter . 
				$enclosure . eregi_replace($converted_delimiter, "", $quantity) . $enclosure . 
				$converted_delimiter . $print_categories . "EOREOR\n";
	
	
	 if ( $data[$_SESSION['row_array']['title']] != 'Title' ) {
	$convert = $convert . $row_data;
	}
	
	
	
    for ($c=0; $c < $num; $c++) {
		
		if ( $debugger ) {
        echo "<td valign='top'>&nbsp;" . $data[$c] . "&nbsp;</td>\n";  // Debugging
		}
		
		$count = $count + substr_count($data[$c], "\n");
    }
	
	$count = $count + 1;  // End of line in field
	
	 // Debugging
	if ( $debugger ) {
	echo "</tr>";
    echo "<tr><td colspan='$num'> $num fields in spreadsheet row $row , ending in file '$file' at " . ftell($handle) . " bytes<br><br><br> </td></tr>\n";
	
	}

$file_pointer = ftell($handle);

}

if ( $debugger ) {
echo "</table>";  // Debugging
}


fclose($handle);


if ( $debugger ) {
echo "</table>";  // Debugging
echo "<p>File pointer ended at $file_pointer bytes.</p>";  // Debugging
}




}


if ( !$debugger && !$_GET['wait'] && !$_GET['stop_parsing'] ) {


$make_name = $file;
$make_name = eregi_replace(".csv", "", $make_name);
$make_name = eregi_replace("(.*)"."/", "", $make_name);

$split_file = $converted_files . $make_name . "_section_" . $split_count . ".csv";


if ( $convert ) {

$convert = $converted_header . $convert;


$convert = strrev($convert); 

$convert = strstr($convert, "ROEROE");

$convert = strrev($convert); 


$write_files = fopen($split_file, 'w');
fwrite($write_files, $convert);

fclose($write_files);

	if (function_exists("chmod")) {
	chmod ($split_file, 0666);
	}

$split_count = $split_count + 1;
?>
<div style='padding: 20px;'><b style='color: red;'>Processing, please wait...</div>
<script type="text/javascript">
setTimeout("window.location.href = '<?php echo $_SERVER['PHP_SELF'] . "?csv_split=" . $file . "&wait=1&split_count=" . $split_count . "&file_pointer=" . $file_pointer . "&g_row=" . ($_GET['g_row'] + $row); ?>'",1000);
</script>
<?php
exit;

}

else {
$_SESSION['row_array'] = FALSE;
$counted = $split_count - 1;
echo "<div style='padding: 20px;'><b style='color: red;'>Processed raw conversion file # $counted (spreadsheet rows ".($counted * $max - $max + 1)." through ".($_GET['g_row'] + $row).")...the file '$file' is finished being 	split into $counted pieces...please continue to wait as these raw conversion files are consolidated into groups of $merge_amount raw files per file...if you are not redirected in a few seconds, <a href='dfd.file.merge.php' style='text-decoration: underline; font-weight: bold; color: red;'>please click here</a>.</b></div>";
?>
<script type="text/javascript">
setTimeout("window.location.href = 'dfd.file.merge.php'",10000);
</script>
<?php
exit;
}



}


?>


<br /><br /><br />
<div align="center"><a href="http://www.dragonfrugal.com/php-bin/online-services/help-desk/" target="_blank"><b>DFD Turbolist Converter Support</b></a> &nbsp;&nbsp;||&nbsp;&nbsp; <a href="http://www.dragonfrugal.com/proprietary/dfdturbolistconverter/check.version.php?dfd_turbolist_version=<?=$program_version?>" target="_blank"><b>Version <?=$program_version?> Upgrade Check</b></a></div>

<?php  require(DIR_WS_INCLUDES . 'footer.php');   // Zencart integration  ?>

</body>
</html>
<?php

  require('includes/application_bottom.php');  // Zencart integration
 
/*
echo "<br clear='all'>Sessions: <pre>";
print_r($_SESSION);
echo "</pre>";
*/

?>

