<?php



////////////////////////////////////////////////////////////////////////
function import_image($image_path, $local_dir, $copy_name) {

$image_path = trim($image_path);

	if ( eregi(".gif", $image_path) ) {
	$ext = '.gif';
	}
	elseif ( eregi(".png", $image_path) ) {
	$ext = '.png';
	}
	elseif ( eregi(".jpg", $image_path) ) {
	$ext = '.jpg';
	}
	else {
	$ext = '.jpg';
	}

// create a new CURL resource
$ch = curl_init();

// set URL and other appropriate options
curl_setopt($ch, CURLOPT_URL, $image_path);
curl_setopt($ch, CURLOPT_HEADER, false);
curl_setopt($ch, CURLOPT_BINARYTRANSFER, true);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

set_time_limit(300); # 5 minutes for PHP
curl_setopt($ch, CURLOPT_TIMEOUT, 300); # and also for CURL

$outfile = fopen($local_dir . $copy_name . $ext, 'wb');
curl_setopt($ch, CURLOPT_FILE, $outfile);

// grab file from URL
curl_exec($ch);
fclose($outfile);

// close CURL resource, and free up system resources
curl_close($ch);

		if (function_exists("chmod")) {
		chmod ($local_dir . $copy_name . $ext, 0777);
		}

	if ( $outfile ) {
	return $copy_name . $ext;
	}
	else {
	return $image_path;
	}

}
////////////////////////////////////////////////////////////////////////




////////////////////////////////////////////////////
function strip_title($string) {

$string = eregi_replace("a", "", $string);
$string = eregi_replace("e", "", $string);
$string = eregi_replace("i", "", $string);
$string = eregi_replace("o", "", $string);
$string = eregi_replace("u", "", $string);
$string = eregi_replace("\t", "", $string);
$string = eregi_replace(" ", "", $string);



$string = eregi_replace("</i>", "", $string);
$string = eregi_replace("<b>", "", $string);
$string = eregi_replace("</b>", "", $string);
$string = eregi_replace("\r", "", $string);
$string = eregi_replace("\n", "", $string);
$string = eregi_replace("&nbsp;", "", $string);

 // Strip all other non-alphanumeric characters
$string = preg_replace("/[^a-zA-Z0-9s]/", "", $string);

return $string;

}
//////////////////////////////////////////////////////




//////////////////////////////////////////////////////////
function clean_header($header, $enclosure) {
$header = trim(strtolower($header));
$header = eregi_replace($enclosure, "", $header);
$header = eregi_replace("\n\r", "", $header);
$header = eregi_replace("\r\n", "", $header);
$header = eregi_replace("\n", "", $header);
$header = eregi_replace("\r", "", $header);
$header = eregi_replace(" ", "", $header);
return $header;
}
//////////////////////////////////////////////////////////




////////////////////////////////////////////////////
function string_length($string, $number) {

$length = strlen($string);

	if ( $length > $number ) {
	$strip = $length - $number;
	}
	elseif ( $number > $length ) {
	$strip = $number - $length;
	}
	else {
	$strip = 0;
	}

return substr_replace($string, '', -$strip, $strip);

}
//////////////////////////////////////////////////////



function get_content($url) {


$ch = curl_init();

curl_setopt ($ch, CURLOPT_URL, $url);
curl_setopt ($ch, CURLOPT_HEADER, 0);

ob_start();

curl_exec ($ch);
curl_close ($ch);

$string = ob_get_contents();

ob_end_clean();


return trim($string);

}




///////////////////////////////////////////////////////
function return_category($subcategory_count, $cat_id, $app_id_here, $site_id_here) {

$cat_id = trim($cat_id);

	if ( is_numeric($cat_id) ) {
	$url = get_content("http://open.api.ebay.com/Shopping?callname=GetCategoryInfo&appid=".$app_id_here."&version=533&siteid=".$site_id_here."&CategoryID=" . $cat_id); 
	}

//$url = "<CategoryNamePath>Jewelry & Watches:Watches:Wristwatches</CategoryNamePath>";  // Debugging


eregi("<CategoryNamePath>(.*)</CategoryNamePath>", $url, $category_info); 


// ***Un-comment the 2 lines below to debug, and final string on the last line***
// echo $category_info[0]; 
// echo "\n\n<p><br>\n\n";

$data_parse = $category_info[0];


$data_parse = eregi_replace("(.*)"."<CategoryNamePath>", "", $data_parse);
$data_parse = eregi_replace("</CategoryNamePath>"."(.*)", "", $data_parse);

/*
$data_parse = trim($data_parse);

	if ( substr($data_parse, -1, 1) == 1 ) {
	$data_parse = substr_replace($data_parse, "", -1, 5);
	}
*/
// ***Un-comment this to debug, and the two commented lines above***
// echo $data_parse; 
		
		
	// Debugging
	//$target = $ebay_categories['category_1466'];
	
	$target = trim($data_parse);
	
	$ebay_subcategories = explode(":", $target);
	
	if ( sizeof($ebay_subcategories) > 0 ) {
	
	
		if ( trim(strtolower($ebay_subcategories[0])) == "ebay motors" ) {
		unset($ebay_subcategories[0]);
		}
		// Debugging
		/*
		foreach( $ebay_subcategories as $subcategory ) {
		$results = $results . $subcategory . " &gt; ";
		}
		*/
	
	}
	else {
	$ebay_subcategories[0] = 'Miscellaneous';
	}

	while ( sizeof($ebay_subcategories) > $subcategory_count ) {
	unset($ebay_subcategories[sizeof($ebay_subcategories)-1]);
	}
	
//return $category_info[0];  // Debugging
return $ebay_subcategories;

}
////////////////////////////////////////////////////////////

?>